--[[
		MicroLua DS MP3 player
		by Headshot#7237
		
		Play an MP3 file launched from the shell
]]

if not playMP3 then return end

local run = true
local pause = false
local stop = false
local wide_title = #playMP3 >= 43
local option = 1
local x = wide_title and 0 or 128-((#playMP3*6)/2)
local x_timer = 60*3

local timer = Timer.new()
timer:start()

MP3.play(playMP3)
while run do
	Controls.read()

	if Keys.newPress.A then
		if option == 0 and not stop then
			MP3.stop()
			timer:stop()
			timer:reset()
			pause = false
			stop = true

		elseif option == 1 then
			if not stop then
				pause = not pause
				if pause then
					MP3.pause()
					timer:stop()
				else
					MP3.resume()
					timer:start()
				end

			else
				stop = false
				MP3.play(playMP3)
				timer:start()
			end

		elseif option == 2 then
			run = false
		end

	elseif Keys.newPress.Right then
		option = option+1
		if option > 2 then option = 0 end

	elseif Keys.newPress.Left then
		option = option-1
		if option < 0 then option = 2 end
	end

	if wide_title then
		if x_timer > 0 then x_timer = x_timer - 1
		elseif x_timer <= 2 and x <= 256-(#playMP3*6) then
			x_timer = 60*3
			x = 0
		else
			x = x - 0.5
			if x <= 256-(#playMP3*6) then
				x_timer = 60*3
			end
		end
	end


	if not stop and not pause and not MP3.isPlaying() then
		MP3.stop()
		timer:stop()
		timer:reset()
		stop = true
	end


	local fps = NB_FPS.." FPS"
	screen.print(SCREEN_UP, 256-(#fps*6), 192-8, fps)
	screen.print(SCREEN_UP, 128-((12*6)/2), 64, "Now playing:")
	screen.print(SCREEN_UP, x, 96, playMP3)
	
	local timervalue = timer:getTime()
	local secs = math.floor(timervalue / 1000)
	local mins = math.floor(secs / 60)
	local timetext = string.format("%.2d:%.2d", mins, secs%60)
	screen.print(SCREEN_DOWN, 128-((#timetext*6)/2), 192-64, timetext)
	
	screen.drawFillRect(SCREEN_DOWN, 128-32+(option*24), 192-52, 128-16+(option*24), 192-36, Color.new(8,8,8))
	if pause or stop then
		screen.drawTriangle(SCREEN_DOWN,
							128-4, 192-48,
							128-4, 192-40,
							128+4, 192-44)
	else
		screen.drawFillRect(SCREEN_DOWN, 128-4, 192-48, 128-2, 192-40, Color.new(31,31,31))
		screen.drawFillRect(SCREEN_DOWN, 128+2, 192-48, 128+4, 192-40, Color.new(31,31,31))
	end
	
	if not stop then
		screen.drawFillRect(SCREEN_DOWN, 128-28, 192-48, 128-20, 192-40, Color.new(31,31,31))
	end
	
	screen.drawLine(SCREEN_DOWN, 128+20, 192-48, 128+28, 192-40, Color.new(31,31,31))
	screen.drawLine(SCREEN_DOWN, 128+28, 192-48, 128+20, 192-40, Color.new(31,31,31))
	
	render()
end

MP3.stop()
timer:stop()
timer:reset()
timer = nil
collectgarbage()