-- Squishy Bird DS

function rand(ind)
	return math.floor(math.random()*(ind*2)) % ind
end
math.randomseed(os.time())

function clamp(v, min, max)
	if v < min then return min
	elseif v > max then return max end
	return v
end

dofile("lib/bird.lua")
dofile("lib/pipe.lua")
dofile("lib/scorefont.lua")
local bg = Image.load("data/sprites/background-day.png", RAM)
local ground = Image.load("data/sprites/base.png", RAM)
local msg = Image.load("data/sprites/message.png", RAM)
local gameover = Image.load("data/sprites/gameover.png", RAM)
snd_whoosh = WAV.load("data/audio/swoosh.wav")
local menuAlpha = 100
local blackAlpha = 0
local music = true
ground_y = 192-24
score = 0
exitGame = false
menuState = 1
local timer = Timer.new()

function newBackground()
	local bgs = {"day", "night"}
	Image.destroy(bg)
	bg = nil
	collectgarbage()
	bg = Image.load("data/sprites/background-"..bgs[rand(2) + 1]..".png", RAM)
end

timer:start()
bird.init()
pipe.init()
scorefont.init()
MP3.setVolume(64)

while not exitGame do
	Controls.read()
	if menuState > 0 and (Keys.newPress.A or Stylus.newPress) then -- start game
		WAV.play(snd_whoosh, 3)
		menuState = menuState - 2
		menuAlpha = 0
		blackAlpha = 100
		newBackground()
		bird.restart()
		score = 0
		Keys.newPress.A = false
		Stylus.newPress = false
		if music then MP3.play("data/audio/hero.mp3", true) end

	elseif Keys.newPress.Select then
		music = not music
	end

	pipe.tick()
	if menuState <= 0 then
		bird.tick()
		if menuAlpha > 0 then menuAlpha = menuAlpha - 2 end
	end

	screen.blit(SCREEN_UP, 0, 0, bg)
	bird.draw()
	pipe.draw()
	screen.blit(SCREEN_UP, 0, ground_y, ground)

	if menuState > 0 or menuAlpha > 0 then
		if menuState > 0 and menuAlpha < 100 then menuAlpha = menuAlpha + 2 end
		screen.setAlpha(menuAlpha)

		screen.blit(SCREEN_UP, 128-(Image.width(msg)/2), 80, msg, 0, 51, Image.width(msg), 25) -- get ready
		screen.blit(SCREEN_UP, 128-(Image.width(msg)/2), 80+48, msg, 0, 116, Image.width(msg), 18) -- tap
		if menuState == 1 or menuState == -1 then
			screen.blit(SCREEN_UP, 128-(Image.width(msg)/2)-4, 52+(math.cos(timer:getTime()/100)*3), msg, 0, 0, Image.width(msg), 23) -- logo
		else
			screen.blit(SCREEN_UP, 128-(Image.width(gameover)/2), 52+(math.cos(timer:getTime()/100)*3), gameover)
		end
		
		local text = "Press SELECT to toggle music"
		local text2 = music and "ON" or "OFF"
		local textcol = music and Color.new(0,0,31) or Color.new(31,0,0)
		screen.print(SCREEN_UP, 128-((#text*6)/2), 192-16, text, 0)
		screen.print(SCREEN_UP, 128-((#text2*6)/2), 192-8, text2, textcol)
		
		screen.setAlpha(100)
	end
	
	scorefont.draw(24)

	if blackAlpha > 0 then
		screen.setAlpha(blackAlpha)
		blackAlpha = blackAlpha - 4

		screen.drawFillRect(SCREEN_UP, 0, 0, 256, 192, 0)
		screen.setAlpha(100)
	end

	render()
end

MP3.stop()
MP3.setVolume(127)
WAV.stop(3)
WAV.free(snd_whoosh)
Image.destroy(bg)
Image.destroy(ground)
Image.destroy(msg)
Image.destroy(gameover)
bird.destroy()
pipe.destroy()
scorefont.destroy()
timer:stop()
timer = nil
snd_whoosh = nil
bg = nil
ground = nil
ground_y = nil
bird = nil
pipe = nil
scorefont = nil
collectgarbage()