pipe = {}
local snd_pipe

function pipe.init()
	snd_pipe = WAV.load("data/audio/pipe.wav")

	pipe.img = Image.load("data/sprites/pipe.png", VRAM)
	pipe.img2 = Image.load("data/sprites/pipe2.png", VRAM)
	pipe.frame_width = Image.width(pipe.img)/3
	pipe.x = 128-(pipe.frame_width/2)
	pipe.y = 48
	pipe.vspeed = 0
	pipe.squishing = false
	pipe.squishtick = -1
end


function pipe.tick()
	pipe.squishing = (pipe.y >= 84)
	if pipe.squishing then
		if pipe.squishtick < 0 then pipe.squishtick = 4
		elseif pipe.squishtick == 0 then pipe.vspeed = -6 pipe.squishtick = -1
		else pipe.squishtick = pipe.squishtick - 1
		end
	end
	
	if pipe.y == 48 and (Keys.newPress.A or Stylus.newPress) then
		pipe.vspeed = 6
		WAV.play(snd_pipe, 4)
	end
	
	pipe.y = pipe.y + pipe.vspeed
	if pipe.y < 48 or pipe.y > 84 then
		pipe.y = clamp(pipe.y, 48, 84)
		pipe.vspeed = 0
	end
end


function pipe.draw()
	local bloodframe = clamp(math.ceil(score/100), 0, 2) * pipe.frame_width
	screen.blit(SCREEN_UP, pipe.x, -Image.height(pipe.img)+pipe.y, pipe.img2, bloodframe, 0, pipe.frame_width, Image.height(pipe.img)) -- top pipe
	screen.blit(SCREEN_UP, pipe.x, ground_y-pipe.y, pipe.img, bloodframe, 0, pipe.frame_width, Image.height(pipe.img)) -- bottom pipe
end


function pipe.destroy()
	WAV.stop(4)
	WAV.free(snd_pipe)
	Image.destroy(pipe.img)
	Image.destroy(pipe.img2)
	pipe.img = nil
	pipe.img2 = nil
	snd_pipe = nil
	collectgarbage()
end