scorefont = {
	{x=00, y=00, w=12, h=18}, -- 0
	{x=12, y=00, w=08, h=18}, -- 1
	{x=20, y=00, w=12, h=18}, -- 2
	{x=32, y=00, w=12, h=18}, -- 3
	{x=44, y=00, w=12, h=18}, -- 4

	{x=00, y=18, w=12, h=18}, -- 5
	{x=12, y=18, w=12, h=18}, -- 6
	{x=24, y=18, w=12, h=18}, -- 7
	{x=36, y=18, w=12, h=18}, -- 8
	{x=48, y=18, w=12, h=18}, -- 9
}

function scorefont.init()
	scorefont.img = Image.load("data/sprites/scorefont.png", VRAM)
end

function scorefont.draw(y)
	local x = 128
	local scorestr = tostring(score)
	local digits = {}

	for i=1, #scorestr do
		local digit = tonumber(scorestr:sub(i, i))+1
		x = x - ((scorefont[digit].w)/2)+0.5
		table.insert(digits, scorefont[digit])
	end
	
	for i, num in pairs(digits) do
		screen.blit(SCREEN_UP, x, y, scorefont.img, num.x, num.y, num.w, num.h)
		x = x + num.w-1
	end
end

function scorefont.destroy()
	Image.destroy(scorefont.img)
	scorefont.img = nil
	collectgarbage()
end